博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
cf251.2.C (构造题的技巧)
阅读量:4679 次
发布时间:2019-06-09

本文共 2981 字,大约阅读时间需要 9 分钟。

C. Devu and Partitioning of the Array
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Devu being a small kid, likes to play a lot, but he only likes to play with arrays. While playing he came up with an interesting question which he could not solve, can you please solve it for him?

Given an array consisting of distinct integers. Is it possible to partition the whole array into k disjoint non-empty parts such that p of the parts have even sum (each of them must have even sum) and remaining k - p have odd sum? (note that parts need not to be continuous).

If it is possible to partition the array, also give any possible way of valid partitioning.

Input

The first line will contain three space separated integers nkp (1 ≤ k ≤ n ≤ 105; 0 ≤ p ≤ k). The next line will contain n space-separated distinct integers representing the content of array aa1, a2, ..., an (1 ≤ ai ≤ 109).

Output

In the first line print "YES" (without the quotes) if it is possible to partition the array in the required way. Otherwise print "NO" (without the quotes).

If the required partition exists, print k lines after the first line. The ith of them should contain the content of the ith part. Print the content of the part in the line in the following way: firstly print the number of elements of the part, then print all the elements of the part in arbitrary order. There must be exactly p parts with even sum, each of the remaining k - p parts must have odd sum.

As there can be multiple partitions, you are allowed to print any valid partition.

Sample test(s)
input
5 5 3 2 6 10 5 9
output
YES 1 9 1 5 1 10 1 6 1 2
input
5 5 3 7 14 2 9 5
output
NO
input
5 3 1 1 2 3 7 5
output
YES 3 5 1 3 1 7 1 2

 

#include
using namespace std;int n , k , p ;vector
o , e ;int op , ep ;int m ;int main () { cin >> n >> k >> p ; p = k-p ; for (int i = 0 ; i < n ; i ++) { int x ; cin >> x ; if (x & 1) o.push_back (x) ; else e.push_back (x) ; } n = o.size () ; m = e.size () ; if (n < p || n-p & 1 || (n-p)/2+m < k-p) { puts ("NO") ; return 0 ; } puts ("YES") ; op = 0 , ep = 0 ; for (; op < p-1 ;) printf ("1 %d\n" , o[op++]) ; for (int i = 0 ; i < k-p-1 ; i ++) { if (ep < m) printf ("1 %d\n" , e[ep++]) ; else printf ("2 %d %d\n" , o[op++] , o[op++]) ; } if (p && k-p) printf ("1 %d\n" , o[op++]) ; printf ("%d " , n-op + m-ep) ; while (op < n) printf ("%d " , o[op++]) ; while (ep < m) printf ("%d " , e[ep++]) ; puts ("") ; return 0 ;}

  这个构造题,跟14年牡丹江的一道题的构造思路有些相似的地方。

为了防止复杂化思路,你在进行的每一步操作都应该尽可能 -----符合题设的条件

并不使问题进一步复杂化。

这道题还需要的一个技巧是,因为要把所有的元素输出,所以用了两个变量op,ep来控制长度。

转载于:https://www.cnblogs.com/get-an-AC-everyday/p/4756013.html

你可能感兴趣的文章
Codeforces Round #277.5 (Div. 2) B. BerSU Ball【贪心/双指针/每两个跳舞的人可以配对,并且他们两个的绝对值只差小于等于1,求最多匹配多少对】...
查看>>
loj 6053 简单的函数 —— min_25筛
查看>>
git教程学习集合
查看>>
20145228《信息安全系统设计基础》第四次实验实验报告
查看>>
201521123042 《Java程序设计》 第10周学习总结
查看>>
JQuery Easyui引入easyui-lang-zh_CN.js后出现乱码的问题解决方法
查看>>
cookie domain port
查看>>
springboot中starters 提供的常用的依赖
查看>>
第二章
查看>>
Java常用的非受检异常
查看>>
HDOJ-2054
查看>>
centos7安装eclipse
查看>>
Web:AJAX的详解
查看>>
两种比较器Comparable 和 Comparator
查看>>
S2JDBC テーブルを利用した独自仕様のid採番メソッド
查看>>
P3698 [CQOI2017]小Q的棋盘
查看>>
动态规划入门 洛谷P2409 Y的积木
查看>>
【第一季】CH04_FPGA设计Verilog基础(一)Enter a post title
查看>>
telnet不能用!!!提示:-bash: telnet: command not found
查看>>
隐式转换的一点想法
查看>>